Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 2969)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 2970)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in old large-scale forcing mode
+! 
+! 2964 2018-04-12 16:04:03Z Giersch
 ! Calculation of fixed number of output time levels for parallel netcdf output
 ! has been revised (based on calculations in netcdf_interface_mod)
@@ -644,6 +647,5 @@
 
     USE lsf_nudging_mod,                                                       &
-        ONLY:  lsf_nudging_check_parameters, lsf_nudging_check_data_output_pr, &
-               qsws_surf, shf_surf
+        ONLY:  lsf_nudging_check_parameters, lsf_nudging_check_data_output_pr
 
     USE kinds
@@ -2004,18 +2006,9 @@
           ELSEIF ( ibc_pt_b == 1 )  THEN
              constant_heatflux = .TRUE.
-             IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.   &
-                  .NOT.  land_surface )  THEN
-                surface_heatflux = shf_surf(1)
-             ELSE
-                surface_heatflux = 0.0_wp
-             ENDIF
+             surface_heatflux = 0.0_wp
           ENDIF
        ENDIF
     ELSE
-        constant_heatflux = .TRUE.
-        IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.        &
-             large_scale_forcing  .AND.  .NOT.  land_surface )  THEN
-           surface_heatflux = shf_surf(1)
-        ENDIF
+       constant_heatflux = .TRUE.
     ENDIF
 
@@ -2132,15 +2125,8 @@
              ELSEIF ( ibc_q_b == 1 )  THEN
                 constant_waterflux = .TRUE.
-                IF ( TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-                   surface_waterflux = qsws_surf(1)
-                ENDIF
              ENDIF
           ENDIF
        ELSE
           constant_waterflux = .TRUE.
-          IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.      &
-               large_scale_forcing )  THEN
-             surface_waterflux = qsws_surf(1)
-          ENDIF
        ENDIF
 
Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2969)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2970)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in old large-scale forcing mode
+! 
+! 2938 2018-03-27 15:52:42Z suehring
 ! Further improvements for nesting in larger-scale model
 ! 
@@ -62,10 +65,13 @@
     USE control_parameters,                                                    &
         ONLY:  bc_lr, bc_ns, bc_pt_b, bc_q_b, constant_diffusion,              &
+               constant_heatflux, constant_waterflux,                          &
                data_output_pr, dt_3d, end_time, forcing,                       &
                force_bound_l, force_bound_n, force_bound_r, force_bound_s,     &  
-               humidity, intermediate_timestep_count, ibc_pt_b, ibc_q_b,       &
+               humidity, initializing_actions, intermediate_timestep_count,    &
+               ibc_pt_b, ibc_q_b,                                              &
                large_scale_forcing, large_scale_subsidence, lsf_surf, lsf_vert,&
                lsf_exception, message_string, neutral, nudging, passive_scalar,&
-               pt_surface, ocean, q_surface, surface_pressure, topography,     &
+               pt_surface, ocean, q_surface, surface_heatflux,                 &
+               surface_pressure, surface_waterflux, topography,                &
                use_subsidence_tendencies
 
@@ -729,5 +735,5 @@
 
        IF ( large_scale_forcing  .AND.  ( bc_lr /= 'cyclic'  .OR.              &
-                                       bc_ns /= 'cyclic' ) )  THEN
+                                          bc_ns /= 'cyclic' ) )  THEN
           message_string = 'Non-cyclic lateral boundaries do not allow for &'//&
                         'the usage of large scale forcing from external file.'
@@ -1472,4 +1478,14 @@
 
        ENDIF
+!
+!--    Surface heat- and waterflux will be written later onto surface elements 
+       IF ( .NOT.  neutral  .AND.  constant_heatflux  .AND.                    &
+            TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+             surface_heatflux = shf_surf(1)
+       ENDIF
+       IF ( humidity  .AND.  constant_waterflux  .AND.                         &
+            TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+             surface_waterflux = qsws_surf(1)
+       ENDIF
 
        surface_pressure = p_surf(nt) + fac * ( p_surf(nt+1) - p_surf(nt) )
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2969)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2970)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Remove un-necessary initialization of surface elements in old large-scale 
+! forcing mode
+! 
+! 2963 2018-04-12 14:47:44Z suehring
 ! Introduce index for vegetation/wall, pavement/green-wall and water/window 
 ! surfaces, for clearer access of surface fraction, albedo, emissivity, etc. .
@@ -2089,12 +2093,4 @@
                             surf%shf(num_h) = wall_heatflux(0) *               &
                                                  heatflux_input_conversion(k-1)
-                         ENDIF
-!
-!--                      Initialize shf with data from external file LSF_DATA. Will 
-!--                      be done directly in ls_foring_surf
-!--                      Attention: Just a workaround, need to be revised!!!
-                         IF ( large_scale_forcing .AND. lsf_surf )  THEN
-!                             CALL ls_forcing_surf ( simulated_time )
-!                             surf%shf(num_h) = shf(j,i)  
                          ENDIF
                       ENDIF